# copy current Object and Meta database backups to historical database backup directory 
# to the database device file name.

typeset src_dir="${1:?"Error: Missing required param <src_dir>"}"
typeset dst_dir="${2:?"Error: Missing required parameter for hist server backup <dst_dir>"}"


# Function to intercept print'ed output. If verbose option is set (-v command line switch)
# all output will additionally be redirected to stderr.
vprint()
{
  print -R $(date '+%Y/%m/%d %H:%M:%S') "|" "$*"
}

main()
{
  if [ ! -d $src_dir ]; then;
    vprint "FAILURE: file [$src_dir] does not exist"
    return
  fi
  if [ ! -d $dst_dir ]; then
    vprint "FAILURE: file [$dst_dir] does not exist"
    return
  fi

  # copy to hist server
  typeset MetaFileName=`ls -ltp $src_dir'/'Meta2*.* $src_dir'/'Meta_*.* $src_dir'/'Meta.* | awk 'NR==1 {print $9}'`
  cp -vf $MetaFileName $dst_dir'/'Meta.*

  typeset ObjectFileName=`ls -ltp $src_dir'/'Object2*.* $src_dir'/'Object.* $src_dir'/'Object_*.*| awk 'NR==1 {print $9}'` 
  cp -vf $ObjectFileName $dst_dir'/'Object.*

}
main
