# SID: 1.1
#
# DATEMODIFIED: 01/10/17 08:09:12
#
# Put Tectotbsm.ksh and ihst3tec.exe in the
# TivoliManager\TDS\EventService directory.
#
# The Tivoli BSM Event Enablement service
# must be running.
#
# Invoke it under ksh
#
# Each invocation will send the record read a "TEC" event
# to the event enablement (EE) process. EE will
# forward the event to anyone connected to it.
#
#*******************************************
#*******************************************
#
# Set a variable for each TEC slot that Dave is putting
# in his TEC event.
#

if [ $# -ne 1 ]; then
   print 'usage: sh tectotbsm <filename>' 
   exit
fi

exec 3<&0 <$1
while read TECLINE
do

	source=$(echo "$TECLINE" | awk ' { split($LINE, data, ";") } { print substr(data[2], 8) } ')
	name_value_pairs=$(echo "$TECLINE" | awk ' { split($LINE, data, ";") } { print substr(data[3], 18) } ')
	
	export source
	export name_value_pairs

	#
	# The slots vairable contains a list of each of your TEC slots.
	# If you add slots, then update the slots assignment below.
	#
	SLOTS="source name_value_pairs"
	export SLOTS
	echo "slots are:   $SLOTS"

	#*******************************************
	#*******************************************
	#
	# No need to modify these, they will be supplied
	# by TEC based on the event that Dave builds.
	#
	class=TEC_Generic
	export class
	echo "class is:    $class"

	hostname=`hostname`
	export hostname
	echo "hostname is: $hostname"
	#
	#*******************************************
	#*******************************************

	GEM_ROOT="/TDS/EventService"
	SETUPTBSM="setup_tbsm.sh"
	SETUPTIV="setup_env.sh"

	if [ -n "$windir" ] ; then
	  WINOS=`echo $windir | awk /:/'{ print substr($1,4) }'`
	  WINDRIVE=`echo $windir | awk /:/'{ print substr($1,1,2) }'`
	  if [ -n "$WINOS" ] ; then
		if [ -f $WINDRIVE/$WINOS/system32/drivers/etc/Tivoli/$SETUPTBSM ] ; then
		  . $WINDRIVE/$WINOS/system32/drivers/etc/Tivoli/$SETUPTBSM
		elif [ -f $WINDRIVE/$WINOS/system32/drivers/etc/Tivoli/$SETUPTIV ] ; then
		  . $WINDRIVE/$WINOS/system32/drivers/etc/Tivoli/$SETUPTIV
		else
		  echo "unable to find $SETUPTBSM or $SETUPTIV"
		  exit
		fi
	  else
		echo "Unable to find: $WINOS"
		exit
	  fi
	else
	  echo "windir is not set"
	  exit
	fi

	if [ -n "$LANG" ] ; then
	  if [ ! -d $BINDIR$GEM_ROOT/msg_cat/$LANG ] ; then
		LANG=C
		export LANG
	  fi
	else
	  LANG=C
	  export LANG
	fi

	if [ -n "$NLSPATH" ] ; then
	  NLSPATH=$NLSPATH:$BINDIR$GEM_ROOT/msg_cat/%L/%N:$BINDIR$GEM_ROOT/msg_cat/%L/%N.cat
	else
	  NLSPATH=$BINDIR$GEM_ROOT/msg_cat/%L/%N:$BINDIR$GEM_ROOT/msg_cat/%L/%N.cat
	fi
	export NLSPATH

	PATH=$PATH:$BINDIR$GEM_ROOT/bin:$BINDIR$GEM_ROOT/msg_cat/$LANG
	export PATH


	echo "Calling $BINDIR$GEM_ROOT/ihst3tec"
	$BINDIR$GEM_ROOT/ihst3tec
	retCode=$?

	echo "Completed with rc: $retCode"

	exec 3<&0 3<&-
done

exit
