-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/BatchCycleJobHist.sqv   1.0   Aug 01 2001 13:28:04   BRENT  $
--
-- BatchCycleJobHist.sql
--
-- Module Description
--   Defines the BatchCycleJobHist table.
--   This table is used as an independent store for batch-related events so that
--   the GetBatchCycleJobHist method can be implemented efficiently.

USE Object
GO


IF EXISTS (SELECT * FROM sysobjects WHERE name = 'BatchCycleJobHist' AND type = 'U')
  AND EXISTS (SELECT * FROM syscolumns WHERE id = OBJECT_ID('BatchCycleJobHist') AND name = 'jobid')
BEGIN
  PRINT 'Dropping old BatchCycleJobHist table'
  DROP TABLE BatchCycleJobHist
END

IF NOT EXISTS (SELECT * FROM sysobjects WHERE name = 'BatchCycleJobHist' AND type = 'U')
BEGIN
  PRINT 'Creating table BatchCycleJobHist'
  CREATE TABLE BatchCycleJobHist
  (
    agent_cid                     ClassID  NOT NULL,
    agent_id                      ObjID  NOT NULL,
    agent_ctime                   DATETIME  NOT NULL,
    agent_seqno                   NVARCHAR(16) NULL,
    obj_cid                       ClassID  NOT NULL,
    obj_id                        ObjID  NOT NULL,
    eventcid                      ClassID  NOT NULL,
    eventid                       NUMERIC NOT NULL,
    name                          ObjName  NOT NULL,
    ctime                         DATETIME  NULL,
    detail                        NVARCHAR(255) NULL,
    alertstate                    INT  NULL,
    priority                      INT  NULL,
    currentstate                  INT  NOT NULL,
    desiredstate                  INT  NOT NULL,
    id                            INT  NOT NULL IDENTITY(1,1)
  )
  ALTER TABLE BatchCycleJobHist ADD CONSTRAINT BatchCycleJobHist_PK PRIMARY KEY CLUSTERED(obj_cid, obj_id, eventcid, eventid, agent_ctime)
END
