--
-- $Header:   //ARCHIVE/PVCSROOT/Archive_NLS/DB/SQL/EventHistory.PART.01.sqv   1.2   Aug 10 2001 09:38:02   lin  $ 
--

SET NOCOUNT ON
GO

-------------------------------------------------------------------------------------------------------------------------------
PRINT '******************************* In master database *******************************'
GO

USE master
GO

IF NOT EXISTS (SELECT * FROM master..sysdatabases WHERE name='EventHistory')
BEGIN
  --  RAISERROR('*******************************************', 0, 11)
  --  RAISERROR('ERROR: Missing Required database: EventHistory', 0, 11)
  --  RAISERROR('*******************************************', 0, 11)
  PRINT 'Creating EventHistory database'
  CREATE DATABASE EventHistory
END
GO

-------------------------------------------------------------------------------------------------------------------------------
PRINT '******************************* In EventHistory database *******************************'
GO

USE EventHistory
GO

IF NOT EXISTS (SELECT * FROM systypes WHERE name='ClassID')
  EXEC sp_addtype ClassID, 'NVARCHAR(4)', 'NOT NULL'
GO

IF NOT EXISTS (SELECT * FROM systypes WHERE name='ObjID')
  EXEC sp_addtype ObjID, 'INT', 'NOT NULL'
GO

IF NOT EXISTS (SELECT * FROM systypes WHERE name='ObjName')
  EXEC sp_addtype ObjName, 'NVARCHAR(54)', 'NOT NULL'
GO

------------------------------------------------------------------------------------------------------------------------------
--
PRINT 'Creating table event_table...'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type='U' AND name='event_table')
  DROP TABLE event_table
GO

-- $Archive:   //ARCHIVE/PVCSROOT/Archive_NLS/DB/SQL/EventHistory.PART.01.sqv  $
-- $Revision:   1.2  $
-- $Date:   Aug 10 2001 09:38:02  $
-- $Author:   lin  $
CREATE TABLE event_table
(
  -- Agent generating event
  agent_cid   ClassID,
  agent_id    ObjID,

  -- Event identifiers from agent
  agent_ctime DATETIME,
  agent_seqno VARCHAR(16),

  -- Object receiving event
  obj_cid     ClassID CONSTRAINT event_table_PK PRIMARY KEY CLUSTERED (obj_cid, obj_id, cid, id),
  obj_id      ObjID,

  -- Event attributes
  cid         ClassID,
  id          NUMERIC(16) IDENTITY,
  name	      ObjName,
  ctime	      DATETIME,
  detail      VARCHAR(255) NULL,
  alertstate  INT,
  priority    INT,
  state	      INT,
  tstamp      TIMESTAMP
)
GO

----------------------------------------------------------------------------------
PRINT 'Done.'
GO

