--
-- $Header:   //ARCHIVE/PVCSROOT/Archive_NLS/DB/SQL/EventHistory.PART.02.Single.DB.sqv   1.1   Jun 20 2001 12:53:04   lin  $ 
--

----------------------------------------------------------------------------------
-- This file represents the SQL to be applied to the database
-- after Event.History.Base.sql has been run to setup the database
-- to run with only one database host that contains both the
-- current database and the historical events database
----------------------------------------------------------------------------------
SET NOCOUNT ON 
GO

-------------------------------------------------------------------------------------------------------------------------------
PRINT '******************************* In master database *******************************'
GO

USE master
GO

IF NOT EXISTS (SELECT * FROM master..sysdatabases WHERE name='Object')
BEGIN
  RAISERROR('*******************************************', 0, 11)
  RAISERROR('ERROR: Missing Required database: Object', 0, 11)
  RAISERROR('*******************************************', 0, 11)
END
GO

-------------------------------------------------------------------------------------------------------------------------------
PRINT '******************************* In Object database *******************************'
GO

USE Object
GO

------------------------------------------------------------------------------------------------------------------------------
--
PRINT 'Renaming existing event table as event_legacy...'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type='U' AND name='event')
  EXEC sp_rename 'event', 'event_legacy', 'OBJECT'
GO

------------------------------------------------------------------------------------------------------------------------------
--
PRINT 'Dropping legacy view event_V...'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type='V' AND name='event_V')
  DROP VIEW event_V
GO

------------------------------------------------------------------------------------------------------------------------------
--
PRINT 'Creating view event...'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type='V' AND name='event')
  DROP VIEW event
GO

-- $Archive:   //ARCHIVE/PVCSROOT/Archive_NLS/DB/SQL/EventHistory.PART.02.Single.DB.sqv  $
-- $Revision:   1.1  $
-- $Date:   Jun 20 2001 12:53:04  $
-- $Author:   lin  $
CREATE VIEW event
AS
  SELECT * FROM EventHistory..event_table
GO

----------------------------------------------------------------------------------
PRINT 'Done.'
GO
