-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/FixJobOwners.sqv   1.1   Aug 01 2001 13:31:38   BRENT  $
--
-- FixJobOwners.sql
--
-- This fixes CMVC defect 72710.
--
-- Patch file for setting job owners to sa for jobs that are not currently owned by sa that must be.
-- These jobs fail with messages like:
--   The owner () of job <jobname> does not have server access. 
--

USE msdb
GO

SET NOCOUNT ON
DECLARE fixjobc INSENSITIVE CURSOR FOR
  SELECT name FROM msdb..sysjobs 
  WHERE name IN
  (
    'Delete Old Closed Notes',
    'Monitor Notification Server',
    'Process Pending State Transitions',
    'OPC Check for new daily plan'
  )
OPEN fixjobc
DECLARE @name sysname
FETCH NEXT FROM fixjobc INTO @name
WHILE @@FETCH_STATUS <> -1
BEGIN
  PRINT 'Updating owner for job ''' + @name + ''''
  EXEC sp_update_job @job_name = @name, @owner_login_name = 'sa'
  FETCH NEXT FROM fixjobc INTO @name
END
DEALLOCATE fixjobc
SET NOCOUNT OFF
GO
