-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/OPCEventTypes.sqv   1.0   Aug 01 2001 13:33:40   BRENT  $
--
-- OPCEventTypes.sql
--
-- Module Description
--   Defines the OPC/TWS-related format, action, and data types

USE Object
GO


EXEC asisp_defineFormatType 8, 'OPC',            'Events from Operations Planning and Control'

EXEC asisp_defineActionType 8,  1,  'STATE_CHANGE',         'Changes in object states'
EXEC asisp_defineActionType 8,  2,  'CURRENT_PLAN_UPDATE',  'Updates to the current plan'
EXEC asisp_defineActionType 8,  3,  'OPC_EXCEPTION',        'OPC errors not associated with an operation (e.g. Queue limit exceeded)'
EXEC asisp_defineActionType 8,  4,  'OPERATION_EXCEPTION',  'OPC operation errors'

EXEC asisp_defineDataType   8,  0,  'DATE_TIME',      'Timestamp in the format YYYYMMDDhhmmss.nnnnnn'
EXEC asisp_defineDataType   8,  1,  'SEQ_NO',         'Event sequence number (usually <SMFID>n where n is an integer)'
EXEC asisp_defineDataType   8,  2,  'OBJ_TYPE_ID',    'If present must be a defined class id of up to 4 characters'
EXEC asisp_defineDataType   8,  3,  'OBJECT_NAME',    'Name of object on which the event occurred'
EXEC asisp_defineDataType   8,  4,  'NATIVE_KEY',     'String representation of the registered id of the object in TM/390'
EXEC asisp_defineDataType   8,  5,  'APPID',          'Application ID'
EXEC asisp_defineDataType   8,  6,  'JOBNAME',        'Job name'
EXEC asisp_defineDataType   8,  7,  'IA',             'Input Arrival Time'
EXEC asisp_defineDataType   8,  8,  'WKSTNID',        'Workstation ID'
EXEC asisp_defineDataType   8,  9,  'STATE',          'State'
EXEC asisp_defineDataType   8, 10,  'OPID',           'Operation Identifier'
EXEC asisp_defineDataType   8, 11,  'RESOURCE',       'Name of resource for wait messages'
EXEC asisp_defineDataType   8, 12,  'WAIT_MINUTES',   'Number of minutes for resource wait messages'
EXEC asisp_defineDataType   8, 13,  'JOBNUM',         'JOB Number'
EXEC asisp_defineDataType   8, 14,  'EC',             'Error code for abnormal job termination'
EXEC asisp_defineDataType   8, 15,  'SUBTASK',        'Subtask or Subsystem Name'
EXEC asisp_defineDataType   8, 16,  'Q_PERCENT',      'Queue percent usage'
EXEC asisp_defineDataType   8, 17,  'Q_NAME',         'Queue name'
