-- $Header:   //Archive/PVCSROOT/Archive/DB/sql/OS_V.sqv   1.0   Sep 07 2001 16:49:50   Forthman  $
--
-- OS_V.sql


USE Object
GO

-- Add the cid column to the OS_C table.
IF NOT EXISTS (SELECT * FROM syscolumns AS sc WHERE sc.id = OBJECT_ID('OS_C') AND name = 'cid')
BEGIN
  ALTER TABLE OS_C ADD cid ClassID  DEFAULT 'OS' CHECK (cid = 'OS')
  EXEC("
  UPDATE OS_C SET cid = 'OS'
  ")
END


---------------------------------------------------------------------------------------------------
-- OS_V
PRINT 'Creating view OS_V'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'OS_V' AND type = 'V')
  DROP VIEW OS_V
GO

-- $Archive:   //Archive/PVCSROOT/Archive/DB/sql/OS_V.sqv  $
-- $Revision:   1.0  $
-- $Date:   Sep 07 2001 16:49:50  $
-- $Author:   Forthman  $
create view OS_V as
  select o.id, name, revision, nchild, description, o.ctime, mtime, userid, deleted,
    a._UploadPassword AS _FTPPassword,
    a._UploadUserID AS _FTPUser,
    a._IPAddress,
    a._IPDNSName,
    a._IPLDateTime,
    a._NVDomain,
    a._NVPassword,
    a._NVUser,
    a._RACFAPPLID,
    a._SMFID,
    a._SystemId,
    a._TGMTaskServer,
    a._UploadEnabled,
    a._UploadHost,
    'GENC/STCR-1/ALRS-' + CAST(a._AlertStateID AS VARCHAR) + '/T/Desc'                        AS _AlertState,
    a._AlertStateID,
    'ACPX/OS-'+CAST(a.id AS VARCHAR)+'/PRMX-' + CAST(a._ChildEventMatrixID AS VARCHAR) + '/T' AS _ChildEventMatrix,
    a._ChildEventMatrixID,
    'ATRC/OS-'+CAST(a.id AS VARCHAR)+'/CHEV'                                                  AS _ChildEvents,
    'OS/STCR-1/STTP-' + CAST(a._CurrentStateID AS VARCHAR) + '/T/State'                       AS _CurrentState,
    a._CurrentStateID,
    'OS/STCR-1/STTP-' + CAST(a._DesiredStateID AS VARCHAR) + '/T/State'                       AS _DesiredState,
    a._DesiredStateID,
    'AEPX/OS-'+CAST(a.id AS VARCHAR)+'/PRMX-' + CAST(a._ExceptionMatrixID AS VARCHAR) + '/T'  AS _ExceptionMatrix,
    a._ExceptionMatrixID,
    'ATRC/OS-'+CAST(a.id AS VARCHAR)+'/EXTP'                                                  AS _ExceptionTypes,
    'ATRC/OS-'+CAST(a.id AS VARCHAR)+'/EXCP'                                                  AS _Exceptions,
    'ATRC/OS-'+CAST(a.id AS VARCHAR)+'/MSGD'                                                  AS _MessageDescriptions,
    'ATRC/OS-'+CAST(a.id AS VARCHAR)+'/MESG'                                                  AS _Messages,
    'ATRC/OS-'+CAST(a.id AS VARCHAR)+'/NOTE'                                                  AS _Notes,
    'GENC/STCR-1/OPRI-' + CAST(a._PriorityID AS VARCHAR) + '/T/Priority'                      AS _Priority,
    a._PriorityID,
    a._LogonToLocalPM,
    'ATRC/OS/OMGL-' + CAST(a._OmegamonLoginID AS VARCHAR)                                     AS _OmegamonLogin,
    a._OmegamonLoginID,
    a._UploadPassword,
    a._UploadUserID,
    a._Desc,
    a._HasOwnershipNote,
    a._OmegamonPassword,
    a._OmegamonUserID,
    o.cid
from
  OS_C o,
  OS_A a
where
  o.id = a.id
GO
