-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/Process_OPC_StateChange.sqv   1.0   Aug 01 2001 13:35:54   BRENT  $
--
-- Process_OPC_StateChange.sql
--
-- Module Description
--   Defines the Process_OPC_StateChange stored procedure

USE Object
GO


---------------------------------------------------------------------------------------------------
-- Process_OPC_StateChange
PRINT 'Creating procedure Process_OPC_StateChange'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'Process_OPC_StateChange' AND type = 'P')
  DROP PROCEDURE Process_OPC_StateChange
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/Process_OPC_StateChange.sqv  $
-- $Revision:   1.0  $
-- $Date:   Aug 01 2001 13:35:54  $
-- $Author:   BRENT  $
-- Creates a state change message on a resource managed by OPC.
--
CREATE PROCEDURE Process_OPC_StateChange
  @SourceCID          ClassID,
  @SourceID           ObjID,
  @FormatType         SMALLINT,
  @ActionType         SMALLINT,
  @DATE_TIME          NVARCHAR(30) = NULL,
  @SEQ_NO             NVARCHAR(50) = NULL,
  @APPID              NVARCHAR(16) = NULL,
  @JOBNAME            NVARCHAR(8) = NULL,
  @IA                 NVARCHAR(16) = NULL,
  @WKSTNID            NVARCHAR(4) = NULL,
  @OPID               NVARCHAR(8) = NULL,
  @STATE              NVARCHAR(16) = NULL
AS
  DECLARE @r INT, @datetime DATETIME

  EXEC asisp_convertMVSDateTime @DATE_TIME, @datetime OUTPUT

  SELECT @APPID = RTRIM(@APPID), @JOBNAME = RTRIM(@JOBNAME)

  INSERT StagedOPCEvent(src_cid, src_id, TIME, SEQ_NO, MESSAGE, APPID, WKSTNID, OPID, JOBNAME, IA)
    SELECT @SourceCID, @SourceID, @datetime, @SEQ_NO, 'OPC' + @STATE, @APPID, @WKSTNID, @OPID, @JOBNAME, @IA
GO
