-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/Process_SA390_OPCException.sqv   1.2   Aug 01 2001 13:36:50   BRENT  $
--
-- Process_SA390_OPCException.sql

USE Object
GO

---------------------------------------------------------------------------------------------------
-- Process_SA390_OPCException
PRINT 'Creating procedure Process_SA390_OPCException'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'Process_SA390_OPCException' AND type = 'P')
  DROP PROCEDURE Process_SA390_OPCException
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/Process_SA390_OPCException.sqv  $
-- $Revision:   1.2  $
-- $Date:   Aug 01 2001 13:36:50  $
-- $Author:   BRENT  $
-- Creates an exception on a resource managed by OPC.
--
CREATE PROCEDURE Process_SA390_OPCException
  @SourceCID          ClassID,
  @SourceID           ObjID,
  @FormatType         SMALLINT,
  @ActionType         SMALLINT,
  @DATE_TIME          NVARCHAR(30) = NULL,
  @SEQ_NO             NVARCHAR(50) = NULL,
  @OBJ_TYPE_ID        NVARCHAR(4) = NULL,
  @OBJECT_NAME        NVARCHAR(8) = NULL,
  @NATIVE_KEY         NVARCHAR(10) = NULL,
  @SMFID              NVARCHAR(4) = NULL,
  @RESOURCE_TYPE      NVARCHAR(8) = NULL,
  @EVENT_TYPE         NVARCHAR(255) = NULL,
  @EVENT_STATE        NVARCHAR(16) = NULL,
  @APPID              NVARCHAR(16) = NULL,
  @IA                 NVARCHAR(16) = NULL,
  @WKSTNID            NVARCHAR(4) = NULL,
  @OPID               NVARCHAR(8) = NULL,
  @EVENT_TEXT         NVARCHAR(255) = NULL
AS
  DECLARE @r INT, @datetime DATETIME

  EXEC asisp_convertMVSDateTime @DATE_TIME, @datetime OUTPUT

  SELECT @APPID = RTRIM(@APPID), @OBJECT_NAME = RTRIM(@OBJECT_NAME)

  INSERT StagedOPCEvent(src_cid, src_id, TIME, SEQ_NO, MESSAGE, APPID, WKSTNID, OPID, JOBNAME, IA, MESSAGE_TEXT)
    SELECT @SourceCID, @SourceID, @datetime, @SEQ_NO, @EVENT_TYPE, @APPID, @WKSTNID, @OPID, @OBJECT_NAME, @IA, @EVENT_TEXT
GO
