-- $Header:   //ARCHIVE/Archive_NLS/DB/sql/RegisterACCESS02.sqv   1.0   Aug 09 2001 13:31:38   BRENT  $
--
-- RegisterACCESS02.sql
--
-- Module Description
--   Registers the ACCESS02 message for all MJOB classes

USE Object
GO


---------------------------------------------------------------------------------------------------
-- RegisterACCESS02
PRINT 'Creating procedure RegisterACCESS02'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'RegisterACCESS02' AND type = 'P')
  DROP PROCEDURE RegisterACCESS02
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/sql/RegisterACCESS02.sqv  $
-- $Revision:   1.0  $
-- $Date:   Aug 09 2001 13:31:38  $
-- $Author:   BRENT  $
CREATE PROCEDURE RegisterACCESS02
AS
  DECLARE @err INT, @rc INT

  SET NOCOUNT ON
  DECLARE @tcount INT
  SET @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRANSACTION RegisterACCESS02
  ELSE
    SAVE TRANSACTION RegisterACCESS02

  DECLARE msgdc INSENSITIVE CURSOR FOR
    SELECT DISTINCT ic.cid, m.MsgID
    FROM
      isa_chain AS ic
      JOIN obj_class AS oc ON oc.cid = ic.cid
      LEFT OUTER JOIN MessageDescription_T AS m ON m.obj_cid = ic.cid AND m.obj_id = 0 AND m.MsgID = 'ACCESS02'
    WHERE ic.base_cid IN ( 'MJOB', 'MREG' ) AND oc.flag_abstract = 0
    GROUP BY ic.cid, m.MsgID
    HAVING MsgID IS NULL
  OPEN msgdc
  DECLARE @cid ClassID, @MsgID NVARCHAR(255), @n INT, @Inactive NVARCHAR(16)
  SET @n = 0
  FETCH NEXT FROM msgdc INTO @cid, @MsgID
  WHILE @@FETCH_STATUS <> -1
  BEGIN
    RAISERROR('Registering ACCESS02 message for class %s', 0, 1, @cid) WITH NOWAIT
    SET @n = @n + 1
    IF @cid = 'BATC'
      SET @Inactive = 'Completed'
    ELSE
      SET @Inactive = 'Inactive'
    EXEC asisp_defineMessageDescription
      @cid                = @cid,
      @MsgID              = 'ACCESS02',
      @Description        = 'Job not found active on registration with TBSM object pump',
      @State              = @Inactive,
      @AlertState         = 'Green',
      @Priority           = 'Ignore',
      @Flags              = 1 -- don't register
    FETCH NEXT FROM msgdc INTO @cid, @MsgID
  END
  DEALLOCATE msgdc

  IF @n > 0 AND EXISTS (SELECT * FROM sysobjects WHERE name =  'MessageDescription_A_BASE')
    EXEC("EXEC asisp_syncLocalizedTables")

  SET NOCOUNT OFF
  SELECT * FROM MessageDescription_V WHERE _MsgID = 'ACCESS02'

  IF @tcount = 0
    COMMIT TRANSACTION RegisterACCESS02
GO

DECLARE @r INT
EXEC @r = RegisterACCESS02
IF @r <> 0
  RAISERROR('RegisterACCESS02 failed with error code %d', 11, 1, @r)
GO


IF EXISTS (SELECT * FROM sysobjects WHERE name = 'RegisterACCESS02' AND type = 'P')
  DROP PROCEDURE RegisterACCESS02
GO
