/* $Header:   //archive/archive_nls/db/sql/Reporting_Patch_1_1.sqv   1.0   Aug 31 2001 09:53:10   Dexter  $ */

use Object
GO

if exists (select * from sysobjects where id = object_id('dbo.report_addclassdata') and sysstat & 0xf = 4)
  drop procedure dbo.report_addclassdata
GO

create procedure report_addclassdata
  @totable sysname,
  @dst_col sysname,
  @src_col sysname,
  @source_class ClassID = '',
  @destination_class ClassID = ''
as

----
-- This procedure updates a table which has cid and id columns populated.  It updates
-- the table @totable, setting @dst_col equal to @src_col from the class @source_class.
-- If @src_class is not specified, it looks up data from the class specified by cid
-- on @totable itself.  If the optional @destination_class is specified, it will only
-- update @totable where cid = @destination_class, otherwise it will update all
-- classes on @totable.
----

set nocount on
--set ansi_defaults off

declare @src_class_table sysname, @src_cid ClassID, @dst_cid ClassID, @dst_class ClassID, @src_class ClassID
declare @link_type varchar(4), @link_alias_counter int, @link_alias varchar(5)
declare @link_tables varchar(255), @link_where_clause varchar(255)
declare @link_table sysname, @generation int, @path_id int

if @source_class <> ''
begin
  select @src_class = @source_class
  select @src_class_table = cname + '_V' from obj_class where cid = @src_class
end

if @destination_class = ''
  exec ('declare classcursor insensitive cursor for select distinct cid from ' + @totable + ' where cid <> '''' and not cid is null')
else
  declare classcursor insensitive cursor for select @destination_class
open classcursor
fetch next from classcursor into @dst_class
while @@fetch_status <> -1
begin
  if @source_class = ''
  begin
    select @src_class = @dst_class
    select @src_class_table = cname + '_V' from obj_class where cid = @src_class
  end
  if @src_class<>@dst_class
    declare ccpath insensitive cursor for select generation - 1, path_id from link_path_detail where cid = @dst_class and dst_cid = @src_class
  else
    declare ccpath insensitive cursor for select 0, 0
  open ccpath
  fetch next from ccpath into @generation, @path_id
  while @@fetch_status <> -1
  begin
    select @link_tables = '', @link_where_clause= '', @link_alias_counter = 0
    while @generation>0
    begin
      select @src_cid = src_cid, @dst_cid = dst_cid from link_path_detail
        where cid = @dst_class and path_id = @path_id and generation = @generation
      select @link_type=o.link_type from derived_obj_link o, link_type l
        where o.src_cid=@src_cid and o.dst_cid=@dst_cid and o.link_type=l.link_type and l.flag_parent_child=1 and flag_containment=1
      select @link_table = rtrim(@src_cid) + '_' + rtrim(@dst_cid) + '_' + rtrim(@link_type)
      select @link_alias_counter = @link_alias_counter + 1
      select @link_alias = 'L' + convert(varchar(4),@link_alias_counter)
      select @link_tables = @link_tables + ',' + @link_table + ' ' + @link_alias
      select @link_where_clause = @link_where_clause + @link_alias + '.src_id and ' + @link_alias + '.dst_id='
      select @generation=@generation-1
    end
    fetch next from ccpath into @generation, @path_id

  exec ('update ' + @totable + ' set ' + @dst_col + '=' + 'c.' + @src_col +
    ' from ' + @totable + ' o,' + @src_class_table + ' c' + @link_tables +
    ' where o.cid = ''' + @dst_class + ''' and ' + 'c.id = ' + @link_where_clause + 'o.id')

  end
  deallocate ccpath
  fetch next from classcursor into @dst_class
end
deallocate classcursor
GO

if exists (select * from sysobjects where id = object_id('dbo.report_params') and sysstat & 0xf = 4)
  drop procedure dbo.report_params
GO

create procedure report_params
  @rep_column_list varchar(255),
  @rep_table_list varchar(255),
  @rep_where_clause varchar(255),
  @rep_order_by varchar(255) ='',
  @rep_column_list2 varchar(255) = '',
  @rep_table_list2 varchar(255) = '',
  @rep_where_clause2 varchar(255) = ''
AS

----
-- The code surrounding the main execute below simply makes a test
-- pass of the selection criteria in order to construct a dummy
-- sql select that is used to dynamically create the #reptemp table.
----
/*
Note: this procdure will not compile without the existence of
the following temp table:
create table #params ( cid ClassID, columns varchar(255) null, criteria varchar(255) null, leafcid ClassID)
*/

declare @src_cid ClassID, @dst_cid ClassID, @path_id int
declare @cid ClassID, @columns varchar(255), @criteria varchar(255)
declare @column_list varchar(255), @class_tables varchar(255)
declare @class_table sysname
declare @leaf_cid ClassID, @generation int, @bDone tinyint, @maxclass int, @classcount int
declare @bSqlcomplete tinyint, @bClassonfile tinyint
declare @order_by varchar(255)

set nocount on
--set ansi_defaults off

If @rep_order_by = '' or @rep_order_by is null
  select @order_by = ''
else
  select @order_by = ' order by ' + @rep_order_by

-- This cursor selects a distinct list of leafcid classes
-- from #params, and loops until it finds one that has all
-- the selection criteria class tables in at least one of
-- its paths.

select @bSqlcomplete = 0

declare ccleaf insensitive cursor for
  select distinct leafcid from #params
open ccleaf
fetch next from ccleaf into @leaf_cid
while @@fetch_status <> -1 and @bSqlcomplete = 0
begin
  select @maxclass = count(*) from #params where leafcid = @leaf_cid
  declare cc insensitive cursor for 
    select src_cid,dst_cid,path_id from link_path_detail 
    where cid=@leaf_cid and generation = 1
  open cc

-- Traverse all possible links to the leaf class id
-- until all selection criteria has been encountered

  fetch next from cc into @src_cid, @dst_cid, @path_id
  while @@fetch_status <> -1 and @bSqlcomplete = 0
  begin
    select @classcount = 0
    select @generation = 1
    select @bDone = 0
    select @column_list = '', @class_tables = ''
    while @bDone = 0
      begin
      select @bClassonfile = 0
      select @cid = null, @columns = null, @criteria = null
      select @cid = cid, @columns = columns, @criteria = criteria from #params where cid = @dst_cid and leafcid = @leaf_cid
      if @@rowcount = 1
      begin
        select @bClassonfile = 1
        select @classcount = @classcount + 1
      end
      if not @columns is null and @columns <> ''
      begin
        if @column_list <> ''
          select @column_list = ',' + @column_list
        select @column_list = @columns + @column_list
      end

      if @bClassonfile = 1
      begin
        select @class_table = cname + '_V' from obj_class where cid = @cid
        if @class_tables <> ''
          select @class_tables = @class_tables + ','
        select @class_tables = @class_tables + @class_table
      end

      if @dst_cid = 'ENT'
        select @bDone = 1
      else
        begin
          select @generation = @generation + 1
          select @src_cid=src_cid, @dst_cid=dst_cid from link_path_detail
          where cid=@leaf_cid and dst_cid=@src_cid and generation = @generation and path_id = @path_id
          if @@rowcount < 1
            select @bDone = 1
        end
    end

    if @classcount >= @maxclass
      select @bSqlcomplete = 1
    fetch next from cc into @src_cid, @dst_cid, @path_id
  end
  deallocate cc

  fetch next from ccleaf into @leaf_cid
end
deallocate ccleaf

if @bSqlcomplete = 0
  return

----
-- This begins the execute that creates the #reptemp table using a dummy select,
-- inserts rows into it using all valid structure branches based on #params file,
-- and joins with the main select criteria passed from the report procedure
----

exec("

--Use dummy select to create #reptemp table
--using variables set outside of the exec

select " + @column_list + " into #reptemp from " + @class_tables + " where " + @class_table + ".id=0

declare @src_cid ClassID, @dst_cid ClassID, @path_id int
declare @cid ClassID, @columns varchar(255), @criteria varchar(255)
declare @link_type varchar(4)
declare @link_tables varchar(255), @link_where_clause varchar(255), @column_list varchar(255), @class_tables varchar(255), @criteria_where_clause varchar(255), @class_where_clause varchar(255), @distinct_clause varchar(10)
declare @link_table sysname, @class_table sysname
declare @leaf_cid ClassID, @generation int, @bDone tinyint, @maxclass int, @classcount int
declare @link_alias_counter int, @link_alias varchar(5), @last_link_alias varchar(5)
declare @temp_columns varchar(255), @tempcol varchar(255), @tempcols varchar(255), @epos int, @cpos int
declare @bClassonfile tinyint

set nocount on

-- The outer most loop processes each individual
-- leaf class id (or ultimate destination class id)
-- in the #params table

declare ccleaf insensitive cursor for
  select distinct leafcid from #params
open ccleaf
fetch next from ccleaf into @leaf_cid
while @@fetch_status <> -1
begin

-- Determine the total number of selection criteria classes
-- specified for the leaf class id

  select @maxclass = count(*) from #params where leafcid = @leaf_cid

-- This loop processes all generation 1 links for the leaf class id

  declare cc insensitive cursor for 
    select src_cid,dst_cid,path_id from link_path_detail 
    where cid=@leaf_cid and generation = 1
  open cc
  fetch next from cc into @src_cid, @dst_cid, @path_id
  while @@fetch_status <> -1
  begin
    select @classcount = 0
    select @generation = 1
    select @bDone = 0
    select @link_tables = '', @column_list = '', @link_where_clause = '', @class_tables = '', @criteria_where_clause = '', @class_where_clause = '', @last_link_alias = null, @link_alias_counter = 0, @temp_columns = '', @distinct_clause = ''

-- This loop traverses each branch for the class building
-- the sql that will insert into the #reptemp table

    while @bDone = 0
      begin
      select @bClassonfile = 0
      select @cid = null, @columns = null, @criteria = null
      select @cid = cid, @columns = columns, @criteria = criteria from #params where cid = @dst_cid and leafcid = @leaf_cid
      if @@rowcount = 1
      begin
        select @bClassonfile = 1
        select @classcount = @classcount + 1
      end
	  
      if @bClassonfile = 1
      begin
        if not @columns is null and @columns <> ''
        begin
          if @column_list <> ''
            select @column_list = ',' + @column_list
          select @column_list = @columns + @column_list

-- Parse the #reptemp table column names from the #params columns field

          select @tempcols = ''
          select @epos = charindex('=',@columns)
          while @epos <> 0
          begin
            select @tempcol = substring(@columns,1,@epos - 1)
            select @cpos = charindex(',',@tempcol)
            while @cpos <> 0
            begin
              select @tempcol = substring(@tempcol,@cpos + 1,255)
              select @cpos = charindex(',',@tempcol)
            end
            if @tempcols <> ''
              select @tempcols = @tempcols + ','
            select @tempcols = @tempcols + @tempcol
            select @columns = substring(@columns,@epos + 1,255)
            select @epos=charindex('=',@columns)
          end
          if @temp_columns <> ''
            select @temp_columns = ',' + @temp_columns
          select @temp_columns = @tempcols + @temp_columns
        end
        else
-- If column list is null for the param record that defines
-- the ultimate destination class, use distinct select
-- to summarize to higher level objects
    begin
            if @leaf_cid = @cid
              select @distinct_clause = 'distinct '
          end
      end

      select @link_type=o.link_type from derived_obj_link o, link_type l
        where o.src_cid=@src_cid and o.dst_cid=@dst_cid and o.link_type=l.link_type and l.flag_parent_child=1 and flag_containment=1
      select @link_table = rtrim(@src_cid) + '_' + rtrim(@dst_cid) + '_' + rtrim(@link_type)

-- Construct sequential link table alias to minimize length of link where clause

      select @link_alias_counter = @link_alias_counter + 1
      select @link_alias = 'L' + convert(varchar(4),@link_alias_counter)

      if @link_tables <> ''
        select @link_tables = @link_tables + ','
      select @link_tables = @link_tables + @link_table + ' ' + @link_alias

      if not @last_link_alias is null
      begin
        if @link_where_clause <> ''
          select @link_where_clause = @link_where_clause + 'and '
        select @link_where_clause = @link_where_clause + @link_alias + '.dst_id=' + @last_link_alias + '.src_id '
      end
      select @last_link_alias = @link_alias

      if @bClassonfile = 1
      begin
        if @criteria <> '' and not @criteria is null
          select @criteria_where_clause = @criteria_where_clause + ' and ' + @criteria
        select @class_table = cname + '_V' from obj_class where cid = @cid
        select @class_tables = @class_tables + ',' + @class_table
        select @class_where_clause = @class_where_clause + ' and ' + @class_table + '.id=' + @link_alias + '.dst_id'
      end

      if @dst_cid = 'ENT'
        select @bDone = 1
      else
        begin
          select @generation = @generation + 1
          select @src_cid=src_cid, @dst_cid=dst_cid from link_path_detail
          where cid=@leaf_cid and dst_cid=@src_cid and generation=@generation and path_id=@path_id

          if @@rowcount < 1
            select @bDone = 1
        end
    end

-- This removes the appropriate 'and' keyword if there is no link where clause
-- to allow for the selection of high level objects

    if @link_where_clause = ''
      begin
        if @criteria_where_clause <> ''
          select @criteria_where_clause = substring(ltrim(@criteria_where_clause),4,255)
        else
          select @class_where_clause = substring(ltrim(@class_where_clause),4,255)
      end

-- If this is a valid branch (ie it encountered all selection classes)
-- use the resulting criteria to insert into #reptemp

    if @classcount >= @maxclass
      exec ('insert #reptemp (' +
            @temp_columns + ')' +
	        ' select ' +
            @distinct_clause +
            @column_list + 
            ' from ' + 
            @link_tables +
            @class_tables +
            ' where ' + 
            @link_where_clause + 
            @criteria_where_clause +
            @class_where_clause
      )
    fetch next from cc into @src_cid, @dst_cid, @path_id
  end
  deallocate cc
  fetch next from ccleaf into @leaf_cid
end
deallocate ccleaf

----
-- Now use the input parameters to perform the final join.
----

select " +
  @rep_column_list + " " +
  @rep_column_list2 +
  " from " + 
  @rep_table_list + " " +
  @rep_table_list2 +
  " where " +
  @rep_where_clause + " " +
  @rep_where_clause2 +
  @order_by)

----
-- End of main execute
----

set nocount off

GO
