-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/RowAllocator.sqv   1.1   Aug 09 2001 13:07:42   BRENT  $
--
-- RowAllocator.sql
--
-- Module Description
--   Defines the RowAllocator table, used as a source of continuously incrementing numbers

USE Object
GO


---------------------------------------------------------------------------------------------------
-- RowAllocator

IF NOT EXISTS (SELECT * FROM sysobjects WHERE name = 'RowAllocator' AND type = 'U')
BEGIN
  PRINT 'Creating table RowAllocator'
  CREATE TABLE RowAllocator
  (
     cid         ClassID NOT NULL,
     id          ObjID NOT NULL,
     timestamp   BINARY(8) NOT NULL,
     rowno       INT NOT NULL IDENTITY(0,1)
  )
  ALTER TABLE RowAllocator ADD CONSTRAINT RowAllocator_PK PRIMARY KEY (cid, id, timestamp)
  ALTER TABLE RowAllocator ADD CONSTRAINT RowAllocator_timestamp_rowno_UQ UNIQUE (timestamp, rowno)
END
GO
