-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/UnhandledOPCEvent.sqv   1.0   Aug 01 2001 13:52:26   BRENT  $
--
-- UnhandledOPCEvent.sql
--
-- Module Description
--   Defines the UnhandledOPCEvent table

USE Object
GO


---------------------------------------------------------------------------------------------------
-- UnhandledOPCEvent
GO

IF NOT EXISTS (SELECT * FROM sysobjects WHERE name = 'UnhandledOPCEvent' AND type = 'U')
BEGIN
  PRINT 'Creating table UnhandledOPCEvent'
  CREATE TABLE UnhandledOPCEvent
  (
    ptime           DATETIME NOT NULL,
    reason          NVARCHAR(255) NULL,
    timestamp       BINARY(8) NOT NULL,
    ctime           DATETIME,
    src_cid         ClassID,
    src_id          ObjID,
    TIME            DATETIME NULL,
    SEQ_NO          NVARCHAR(50) NULL,
    MESSAGE         NVARCHAR(255) NULL,
    MESSAGE_TEXT    NVARCHAR(255) NULL,
    APPID           NVARCHAR(16) NULL,
    WKSTNID         NVARCHAR(8) NULL,
    OPID            NVARCHAR(10) NULL,
    JOBNAME         NVARCHAR(8) NULL,
    PRTY            INT NULL,
    IA              NVARCHAR(16) NULL,
    EC              NVARCHAR(8) NULL,
    RESOURCE        NVARCHAR(40) NULL,
    WAIT_MINUTES    INT NULL,
    app_id          ObjID NULL,
    job_cid         ClassID NULL,
    job_id          ObjID NULL,
    EventCID        ClassID NULL,
    EventText       NVARCHAR(255) NULL,
    AlertStateID    INT NULL,
    PriorityID      INT NULL,
    StateID         INT NULL,
    op_id           INT NOT NULL
  )
  ALTER TABLE UnhandledOPCEvent ADD CONSTRAINT UnhandledOPCEvent_PK PRIMARY KEY (ptime, timestamp)
END
