-- $Header:   //Archive/PVCSROOT/Archive/DB/sql/_FindChildEvents.sqv   1.0   Sep 07 2001 16:50:36   Forthman  $
--
-- _FindChildEvents.sql
--

USE Object
GO

---------------------------------------------------------------------------------------------------
-- _FindChildEvents
PRINT 'Creating procedure _FindChildEvents'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = '_FindChildEvents' AND type = 'P')
  DROP PROCEDURE _FindChildEvents
GO

-- $Archive:   //Archive/PVCSROOT/Archive/DB/sql/_FindChildEvents.sqv  $
-- $Revision:   1.0  $
-- $Date:   Sep 07 2001 16:50:36  $
-- $Author:   Forthman  $
create procedure _FindChildEvents
  @cid        ClassID      = null,
  @id         ObjID        = null
as
  declare @sql varchar(255)
  declare @sql2 varchar(255)
  declare @childCID ClassID
  declare @childID ObjID
  declare @childName ObjName

  EXEC asisp_notifyPropagationSlots @cid, @id

  -- prepare a temporary table with the ChildEvents 
  -- for the specified @cid, @id
  select id, name, 
    _ChildCID, 
    _ChildID, 
    _ChildName=convert(varchar(255),""),
    _EventCID, 
    _EventDetail, 
    _EventCount, 
    _Direction, 
    _AlertState, 
    _Priority, 
    _NumOwned, 
    _nCHVH, 
    _SumDirection,
    _LinkedCID=_ChildCID,
    _LinkedID=_ChildID
  into
    #FindChildEvents
  from
    ChildEvent_V v
  where
    _ParentCID=@cid 
    and _ParentID=@id
    and v.deleted=0
    and v._nCHVH > v._NumOwned
  -- cursor over the temporary table, filling in
  -- the _ChildName column with the name of the 
  -- object that produced the child event
  select @sql='select id, _ChildCID, _ChildID from #FindChildEvents'
  exec asisp_declarecursor "FindChildEvents_c", @sql, 1
  open FindChildEvents_c
  fetch next from FindChildEvents_c into @id, @childCID, @childID
  while @@fetch_status <> -1
  begin
    select @sql2='exec asisp_declarecursor "FindChildName_c", 
                          "select name
                                from ' + cname + '_C 
                                where id='+convert(varchar(9), @childID)+'", 1' 
                                      from obj_class where cid=@childCID
    exec(@sql2)
    open FindChildName_c
    fetch next from FindChildName_c into @childName
      update #FindChildEvents set _ChildName=@childName where id=@id
    deallocate FindChildName_c
    fetch next from FindChildEvents_c into @id, @childCID, @childID
  end
  deallocate FindChildEvents_c
  -- select the result set
  select * from #FindChildEvents
  drop table #FindChildEvents
GO
