-- $Header:   //Archive/PVCSROOT/Archive/DB/sql/_GetExceptions.sqv   1.0   Sep 07 2001 16:50:44   Forthman  $
--
-- _GetExceptions.sql
--

USE Object
GO

---------------------------------------------------------------------------------------------------
-- _GetExceptions
PRINT 'Creating procedure _GetExceptions'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = '_GetExceptions' AND type = 'P')
  DROP PROCEDURE _GetExceptions
GO

-- $Archive:   //Archive/PVCSROOT/Archive/DB/sql/_GetExceptions.sqv  $
-- $Revision:   1.0  $
-- $Date:   Sep 07 2001 16:50:44  $
-- $Author:   Forthman  $
create procedure _GetExceptions
  @cid  ClassID,
  @id   ObjID
as
--  raiserror('_GetExceptions %s, %d', 0, 1, @cid, @id)
  EXEC asisp_notifyPropagationSlots @cid, @id

  select
    link_type='ATRC',
    src_cid=@cid,
    src_cno=src.cno,
    src_id=@id,
    dst_cid='EXCP',
    dst_cno=dst.cno,
    id,
    flags=1,
    generation=1,
    id excp_id,
    name,
    revision,
    nchild,
    v.description,
    ctime,
    mtime,
    userid,
    deleted,
    _ParentCID,
    _ParentID,
    _AlertState,
    _DATE,
    _EXCP_CD,
    _EXCP_NAME,
    _EXCP_OBJ_NAME,
    _EXCP_OBJ_TYPE,
    _MSEC,
    _NATIVE_KEY,
    _NumOwned,
    _OBJECT_NAME,
    _OBJ_TYPE_ID,
    _Priority,
    _SEQ_NO,
    _TIME,
    _nEXCH,
    _Owned=0,
    _Owner=CONVERT(varchar(255),''),
    _NoteID=0
  into
    #exceptions
  from
    Exception_V v,
    obj_class src,
    obj_class dst
  where
    _ParentCID = @cid
    and _ParentID = @id
    and deleted = 0
    and src.cid = @cid
    and dst.cid = 'EXCP'

  -- update the owned, noteid, and owner columns
  update
    #exceptions
  set
    #exceptions._Owned = 1,
    #exceptions._NoteID = oe.noteid,
    #exceptions._Owner = n._UserID
  from
    OwnedEvent oe,
    Note_V n
  where
    oe.eventcid = 'EXCP'
    and oe.eventid = #exceptions.id
    and n.id = oe.noteid

  delete
  from
    #exceptions
  where
    deleted = 1
    and _Owned = 0

  select * from #exceptions order by _TIME
GO
