-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/_SetSystemConfiguration.sqv   1.0   Aug 12 2001 17:57:54   BRENT  $
--
-- _SetSystemConfiguration.sql
--
-- Module Description
--   Defines the _SetSystemConfiguration stored procedure

USE Object
GO


---------------------------------------------------------------------------------------------------
-- _SetSystemConfiguration
PRINT 'Creating procedure _SetSystemConfiguration'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = '_SetSystemConfiguration' AND type = 'P')
  DROP PROCEDURE _SetSystemConfiguration
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/_SetSystemConfiguration.sqv  $
-- $Revision:   1.0  $
-- $Date:   Aug 12 2001 17:57:54  $
-- $Author:   BRENT  $
-- Creates or updates a record in the SystemConfiguration table. The combination of groupname and
-- propertyname are unique, and the propertyvalue and propertydatatype are set to the new values.
CREATE PROCEDURE _SetSystemConfiguration
  @cid              ClassID = NULL,
  @id               ObjID   = NULL,
  @groupname        sysname,   -- Name of the configuration group property belong to.
  @propertyname     sysname,   -- Name of the property.
  @propertyvalue    sysname,   -- Property actual value.
  @propertydatatype sysname    -- Property data type such AS NCHAR,LONG, INT, ect.
AS
  -- Add or update information for named property in SystemConfiguration table
  IF NOT EXISTS (SELECT * FROM SystemConfiguration WHERE groupname = @groupname AND propertyname = @propertyname)
    INSERT INTO SystemConfiguration VALUES( @groupname,@propertyname,@propertyvalue ,@propertydatatype )
  ELSE
    UPDATE SystemConfiguration SET
      propertyvalue = @propertyvalue,
      propertydatatype = @propertydatatype
    WHERE
      groupname = @groupname
      AND propertyname = @propertyname
GO

/* Sample:
EXEC _SetSystemConfiguration
  @groupname        = '_GetManagedObjects',
  @propertyname     = 'DESCENDENTS_LIMIT',
  @propertyvalue    = '10000',
  @propertydatatype = 'INT'
SELECT * FROM SystemConfiguration
*/
