-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/alloc_MESG.sqv   1.0   Aug 01 2001 13:14:34   BRENT  $
--
-- alloc_MESG.sql
--
-- Module Description
--   Defines the alloc_MESG stored procedure

USE Object
GO

---------------------------------------------------------------------------------------------------
-- alloc_MESG
PRINT 'Creating procedure alloc_MESG'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'alloc_MESG' AND type = 'P')
  DROP PROCEDURE alloc_MESG
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/alloc_MESG.sqv  $
-- $Revision:   1.0  $
-- $Date:   Aug 01 2001 13:14:34  $
-- $Author:   BRENT  $
-- Custom version of alloc_MESG that allocates in one step rather than a loop
CREATE PROCEDURE alloc_MESG
  @count    int=1
AS
  IF @count = 0
    RETURN

  DECLARE @tcount INT
  SET @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRANSACTION alloc_MESG
  ELSE
    SAVE TRANSACTION alloc_MESG

  DECLARE @last_id INT
  SELECT @last_id = last_id+1 FROM MESG_ID
  UPDATE MESG_ID SET last_id = last_id + @count

  IF @tcount = 0  
    COMMIT TRANSACTION alloc_MESG

  RETURN @last_id
GO
