-- $Header:   //ARCHIVE/Archive/DB/sql/asisp_ca7discardedevents.SQv   1.0   Sep 07 2001 16:20:52   Xiaoyan  $
--
-- asisp_ca7discardedevents.sql
--
-- Module Description
--   Defines the asisp_ca7discardedevents stored procedure

USE Object
GO


---------------------------------------------------------------------------------------------------
-- asisp_ca7discardedevents
PRINT 'Creating procedure asisp_ca7discardedevents'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'asisp_ca7discardedevents' AND type = 'P')
  DROP PROCEDURE asisp_ca7discardedevents
GO

-- $Archive:   //ARCHIVE/Archive/DB/sql/asisp_ca7discardedevents.SQv  $
-- $Revision:   1.0  $
-- $Date:   Sep 07 2001 16:20:52  $
-- $Author:   Xiaoyan  $
-- Process ca7 discarded events 
CREATE PROCEDURE asisp_ca7discardedevents
AS
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRANSACTION asisp_ca7discardedevents
  ELSE
    SAVE TRANSACTION asisp_ca7discardedevents

  -- Unset ca7_discarded_SIRD11 table for all new SIRD-11 based on JOBNUM
  DELETE c FROM ca7_discarded_SIRD11 AS c 
    JOIN StagedCA7InProgress AS s ON c.bcys_id = s.bcys_id AND c.job_num = s.JOBNUM
    AND s.MSG = 'SIRD-11'

  -- Insert new entries FOR SIRD-11 without SYSTEMNAME to ca7_discarded_SIRD11 TABLE 
  INSERT ca7_discarded_SIRD11 
    SELECT DISTINCT bcys_id, JOBNAME, CONVERT(INT, JOBNUM) 
    FROM StagedCA7InProgress 
    WHERE
      MSG = 'SIRD-11'
      AND
      (
        ISNULL(SYSTEMNAME, '') = ''
        OR 
        JCLID = 'NON-EXECUTABLE'
      )

  -- Delete events for bcys_id and job_num in ca7_discarded_SIRD11 
  INSERT ProcessedStagedEvent 
    SELECT s.timestamp_col, GETDATE() 
    FROM StagedCA7InProgress AS s
    JOIN ca7_discarded_SIRD11 AS c ON s.bcys_id = c.bcys_id 
    AND s.JOBNUM = c.job_num
    AND s.JOBNAME = c.job_name

  DELETE s FROM StagedCA7InProgress AS s
    JOIN ca7_discarded_SIRD11 AS c ON s.bcys_id = c.bcys_id 
    AND s.JOBNUM = c.job_num
    AND s.JOBNAME = c.job_name

  -- finish up
  IF @tcount = 0
    COMMIT TRAN asisp_ca7discardedevents
  RETURN 0
GO
