-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/asisp_createUnhandledEvent.sqv   1.0   Aug 01 2001 13:20:36   BRENT  $
--
-- asisp_createUnhandledEvent.sql
--
-- Module Description
--   Defines the asisp_createUnhandledEvent stored procedure

USE Object
GO


---------------------------------------------------------------------------------------------------
-- Add reason column to UnhandledEvent table
IF NOT EXISTS (SELECT * FROM syscolumns WHERE id = OBJECT_ID('UnhandledEvent') AND name = 'reason')
BEGIN
  PRINT 'Adding column ''reason'' to UnhandledEvent table'
  EXEC("
  ALTER TABLE UnhandledEvent ADD
    reason VARCHAR(255) NULL CONSTRAINT UnhandledEvent_reason_DF DEFAULT NULL
  ")
END


---------------------------------------------------------------------------------------------------
-- asisp_createUnhandledEvent
PRINT 'Creating procedure asisp_createUnhandledEvent'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'asisp_createUnhandledEvent' AND type = 'P')
  DROP PROCEDURE asisp_createUnhandledEvent
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/asisp_createUnhandledEvent.sqv  $
-- $Revision:   1.0  $
-- $Date:   Aug 01 2001 13:20:36  $
-- $Author:   BRENT  $
-- Fall-through procedure for recording unhandled events processed by the MVS Event Handler.
-- asisp_decodeDatFileRecord
CREATE PROCEDURE asisp_createUnhandledEvent
  @SourceCID          ClassID,
  @SourceID           ObjID,
  @FormatType         SMALLINT,
  @ActionType         SMALLINT,
  @FormattedEventData VARCHAR(1000) = NULL,
  @RawEventData       VARBINARY(1000) = NULL,
  @Reason             VARCHAR(255) = NULL
AS
  -- If reason was not specified then try to decode and execute the record dynamically
  IF @Reason IS NULL
  BEGIN
    EXEC asisp_decodeDatFileRecord @SourceCID, @SourceID,
      @record = @FormattedEventData,
      @reason = @Reason OUTPUT,
      @execute = 1
  END

  -- If reason field is not null then insert into UnhandledEvent table
  IF @Reason IS NOT NULL
    INSERT UnhandledEvent(src_cid, src_id, format_type, action_type, formatted_data, raw_data, reason)
      SELECT @SourceCID, @SourceID, @FormatType, @ActionType, @FormattedEventData, @RawEventData, @Reason
GO
