-- $Header:   //ARCHIVE/Archive_NLS/DB/sql/asisp_deleteoldexceptions.sqv   1.1   Aug 22 2001 19:23:26   BRENT  $
--
-- asisp_deleteoldexceptions
--
-- Module Description
--   Defines the asisp_deleteoldexceptions stored procedure

USE Object
GO

---------------------------------------------------------------------------------------------------
-- asisp_deleteoldexceptions
PRINT 'Creating procedure asisp_deleteoldexceptions'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'asisp_deleteoldexceptions' AND type = 'P')
  DROP PROCEDURE asisp_deleteoldexceptions
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/sql/asisp_deleteoldexceptions.sqv  $
-- $Revision:   1.1  $
-- $Date:   Aug 22 2001 19:23:26  $
-- $Author:   BRENT  $
-- Regular clean up for exception related tables 
-- Deletes old exceptions that are marked as deleted and have igore priority
-- NVTest was deleted older then a given days
--
CREATE PROCEDURE asisp_deleteoldexceptions
  @daystokeep INT = 7
AS
-- $Archive:   //ARCHIVE/Archive_NLS/DB/sql/asisp_deleteoldexceptions.sqv  $
-- $Revision:   1.1  $
-- $Date:   Aug 22 2001 19:23:26  $
-- $Author:   BRENT  $

  DECLARE @oldest DATETIME
  SELECT @oldest = DATEADD(day, -@daystokeep, GETDATE())
  DECLARE @num_exch INT, @num_excp INT, @num_bch INT, @num_bcjh INT, @num_pdse INT, @num_nvt INT
  DELETE ExceptionHistory_A 
    WHERE _ParentID NOT IN (SELECT id FROM Exception_V WHERE _AlertState <> 1 AND _Priority <> 5 AND deleted = 0)   
    AND ctime > @oldest
  SELECT @num_exch = @@ROWCOUNT
  DELETE ExceptionHistory_C WHERE id NOT IN (SELECT id FROM ExceptionHistory_A)
  SELECT @num_exch = @@ROWCOUNT
  DELETE Exception_C WHERE ctime < @oldest AND deleted = 1
  DELETE Exception_C WHERE id NOT IN (SELECT id FROM Exception_A)
  SELECT @num_excp = @@ROWCOUNT
  DELETE BatchCycleHist WHERE eventcid = 'EXCP' AND eventid NOT IN (SELECT id FROM Exception_C)
  SELECT @num_bch = @@ROWCOUNT
--  DELETE BatchCycleJobHist WHERE eventcid = 'EXCP' AND eventid NOT IN (SELECT id FROM Exception_C)
--  SELECT @num_bcjh = @@ROWCOUNT
  SET @num_bcjh = 0
  DELETE ProcessedStagedEXCP WHERE ptime < @oldest
  SELECT @num_pdse = @@ROWCOUNT
  DELETE NVTest WHERE _DateTime < @oldest
  SELECT @num_nvt = @@ROWCOUNT
  DECLARE @d NVARCHAR(40)
  SELECT @d = CONVERT(NVARCHAR(40), GETDATE(), 113)
  RAISERROR('%s: Total deleted: #Exception=%d, #ExceptionHistory=%d, #BatchCycleHist=%d, #BatchCycleJobHist=%d, #NVTest=%d, #ProcessedStagedEXCP=%d ', 0, 1,
            @d, @num_excp, @num_exch, @num_bch, @num_bcjh, @num_nvt, @num_pdse)

  -- UPDATE excp_count FOR ignore excps
  EXEC asisp_update_excp_counts "_AlertState", "1"
  EXEC asisp_update_excp_counts "_Priority", "5"
  DELETE Exception_A WHERE _nEXCH = 0

  -- fix propagationbucketarray FOR deleted ignore exceptions
  EXEC asisp_fix_pba_ignore
GO
