-- $Header:   //Archive/PVCSROOT/Archive/DB/sql/asisp_fullpath.sqv   1.0   Sep 07 2001 16:38:36   Forthman  $
--
-- asisp_fullpath
--
-- Module Description
--   Defines the asisp_fullpath stored procedure

Use Object
GO

--------------------------------------------------------------------------------------------------
-- asisp_fullpath
PRINT 'Creating procedure asisp_fullpath'
GO

IF EXISTS ( SELECT * FROM sysobjects WHERE name = 'asisp_fullpath' AND type = 'P')
  DROP PROCEDURE asisp_fullpath
GO

-- $Archive:   //Archive/PVCSROOT/Archive/DB/sql/asisp_fullpath.sqv  $
-- $Revision:   1.0  $
-- $Date:   Sep 07 2001 16:38:36  $
-- $Author:   Forthman  $
create procedure asisp_fullpath
  @cid ClassID,
  @id  ObjID,
  @path varchar(255) output
as
  declare @sql varchar(255), @name ObjName, @parent_cid ClassID, @parent_id ObjID
  select @path = null
  while @cid <> 'BUSC' and @cid <> 'LOBC'
  begin
    select @sql = 'declare asisp_fullpath_c cursor for select name' +
      case when flag_direct_containment = 1 then ', _ParentCID, _ParentID' else ', NULL, NULL' end +
      ' from ' + cname + '_V where id=' + convert(varchar(9), @id)
      from obj_class where cid = @cid
    exec(@sql)
    open asisp_fullpath_c
    fetch next from asisp_fullpath_c into @name, @parent_cid, @parent_id
    deallocate asisp_fullpath_c 

    if @path IS null
      select @path = @name
    else
      select @path = @name + '/' + @path

    IF @parent_cid IS NULL
      select @cid = src_cid, @id = src_id from containment where dst_cid = @cid and dst_id = @id
    else
      select @cid = @parent_cid, @id = @parent_id
    if @@rowcount <> 1
      break
  end
GO

