-- $Header:   //Archive/PVCSROOT/Archive/DB/sql/asisp_notifyPropagationSlots.sqv   1.0   Sep 07 2001 16:38:50   Forthman  $
--
-- asisp_notifyPropagationSlots.sql
--

USE Object
GO

---------------------------------------------------------------------------------------------------
-- asisp_notifyPropagationSlots
PRINT 'Creating procedure asisp_notifyPropagationSlots'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'asisp_notifyPropagationSlots' AND type = 'P')
  DROP PROCEDURE asisp_notifyPropagationSlots
GO

-- $Archive:   //Archive/PVCSROOT/Archive/DB/sql/asisp_notifyPropagationSlots.sqv  $
-- $Revision:   1.0  $
-- $Date:   Sep 07 2001 16:38:50  $
-- $Author:   Forthman  $
-- Sends out notifications for all PropagationSlots owned by the specified object
CREATE PROCEDURE asisp_notifyPropagationSlots
  @cid ClassID,
  @id  ObjID
AS
  INSERT INTO PendingNotification(type, fields, detail) 
    SELECT
      et.type,
      CAST(oc.cno AS VARCHAR) + '|' + CAST(ps.id AS VARCHAR) + '|' + CAST(ism.id AS VARCHAR),
      CASE pri.id 
        WHEN 1 THEN ps.Critical
        WHEN 2 THEN ps.High
        WHEN 3 THEN ps.Medium
        WHEN 4 THEN ps.Low
        WHEN 5 THEN ps.Ignore
      END
    FROM
      EventType AS et,
      PropagationSlot AS ps,
      obj_class AS oc,
      SixLevelPri_V AS pri
        JOIN id_string_map AS ism ON ism.string = pri.name
    WHERE
      et.name = 'ObjAttrUpdated'
      AND ps.OwnerCID = @cid
      AND ps.OwnerID = @id
      AND oc.cid = 'PRBA'
      AND pri.id BETWEEN 1 AND 5
GO
