-- $Header:   //Archive/PVCSROOT/Archive/DB/sql/asisp_updatePath.sqv   1.0   Sep 07 2001 16:38:56   Forthman  $
--
-- asisp_updatePath
--
-- Module Description
--   Defines the asisp_updatePath stored procedure

Use Object
GO

--------------------------------------------------------------------------------------------------
-- asisp_updatePath
PRINT 'Creating procedure asisp_updatePath'
GO

IF EXISTS ( SELECT * FROM sysobjects WHERE name = 'asisp_updatePath' AND type = 'P')
  DROP PROCEDURE asisp_updatePath
GO

-- $Archive:   //Archive/PVCSROOT/Archive/DB/sql/asisp_updatePath.sqv  $
-- $Revision:   1.0  $
-- $Date:   Sep 07 2001 16:38:56  $
-- $Author:   Forthman  $
CREATE PROCEDURE asisp_updatePath
  @cid ClassID,
  @id  ObjID
AS
  RAISERROR('asisp_updatePath: @cid=''%s'', @id=%d', 0, 1, @cid, @id)

  -- Standard transaction logic
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRAN asisp_updatePath
  ELSE
    SAVE TRAN asisp_updatePath

  DECLARE @cname VARCHAR(24)
  DECLARE @sql VARCHAR(500)
  DECLARE @path VARCHAR(500)

  EXEC asisp_fullpath @cid, @id, @path OUTPUT

  SELECT @cname = cname FROM obj_class WHERE cid = @cid
  SELECT @sql = "
  UPDATE " + @cname + "_C
    SET _Path = '" + @path + "'
    WHERE cid = '" + @cid + "'
      AND id = " + CONVERT( VARCHAR(8), @id) + "
  "
  EXEC (@sql)

  IF @@ERROR <> 0 
  BEGIN
    RAISERROR( 'asisp_updatePath: Error attempting to update _Path where @cid=%s, @id=%d, @@ERROR=%d', 11, 1, @cid, @id, @@ERROR)
    ROLLBACK TRANSACTION asisp_updatePath
    RETURN -30000
  END
  


  -- Standard transaction logic
  IF @tcount = 0
    COMMIT TRAN asisp_updatePath
  
  RETURN 0
GO

