-- $Header:   //ARCHIVE/Archive_NLS/DB/sql/asisp_updatealertstatehistory.sqv   1.0   Aug 22 2001 19:55:16   BRENT  $
--
-- asisp_updatealertstatehistory.sql
--
-- Module Description
--   Defines the asisp_updatealertstatehistory stored procedure

USE Object
GO


---------------------------------------------------------------------------------------------------
-- asisp_updatealertstatehistory
PRINT 'Creating procedure asisp_updatealertstatehistory'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'asisp_updatealertstatehistory' AND type = 'P')
  DROP PROCEDURE asisp_updatealertstatehistory
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/sql/asisp_updatealertstatehistory.sqv  $
-- $Revision:   1.0  $
-- $Date:   Aug 22 2001 19:55:16  $
-- $Author:   BRENT  $
CREATE PROCEDURE asisp_updatealertstatehistory
  @cid             ClassID,
  @id              ObjID,
  @OldAlertStateID TINYINT,
  @AlertStateID    TINYINT,
  @evt_cid         ClassID,
  @evt_id          ObjID,
  @evt_name        ObjName,
  @evt_priority    TINYINT,
  @evt_alertstate  SMALLINT,
  @evt_ctime       DATETIME,
  @evt_detail      NVARCHAR(255)
AS
  -- If we're not in a tran already then begin one, otherwise create a savepoint
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount > 0
    SAVE TRANSACTION asisp_updatealertstatehistory
  ELSE
    BEGIN TRANSACTION asisp_updatealertstatehistory

  -- The evt_detail param for child events will have a string in the form:"Propagated Child Event: (<cid>, <id>)"
  IF @evt_cid='CHEV' AND @evt_detail IS NOT NULL
  BEGIN
    DECLARE @child_cid ClassID, @child_id ObjID
    DECLARE @nLeftParen INT, @nComma INT, @nRightParen INT
    SELECT @nLeftParen=CHARINDEX(N'(', @evt_detail, 1), @nRightParen=CHARINDEX(N')', @evt_detail, 1), @nComma=CHARINDEX(N',', @evt_detail, 1)
    SELECT @child_cid=SUBSTRING(@evt_detail, @nLeftParen+1, @nComma-@nLeftParen-1)
    SELECT @child_id=SUBSTRING(@evt_detail, @nComma+2, @nRightParen-@nComma-2)
    EXEC asisp_fullpath @child_cid, @child_id, @evt_detail OUTPUT
  END

  INSERT INTO AlertStateHistory(cid, id, OldAlertStateID, AlertStateID, evt_cid, evt_id, evt_name, evt_priority, evt_alertstate, evt_ctime, evt_detail)
  SELECT 
    @cid,
    @id,
    @OldAlertStateID,
    @AlertStateID,
    @evt_cid,
    @evt_id,
    @evt_name,
    @evt_priority,
    @evt_alertstate,
    @evt_ctime,
    ISNULL(@evt_detail,'')

  IF @@ERROR != 0
  BEGIN
    ROLLBACK TRANSACTION asisp_updatealertstatehistory
    RETURN -30000
  END

  -- Commit the transaction if we started it
  IF @tcount = 0
    COMMIT TRANSACTION asisp_updatealertstatehistory
GO
