-- archive\db\sql\ow51302_cleanup.sql
-- SID 1.1
-- Date Modified: 01/10/18 12:52:23
--
-- This cleanup: 
-- 1. delete all  
-- cleanup old database for multiple objects in CA7
CREATE TABLE temp_LOB_BTCY(cid ClassID, id ObjID)
GO
CREATE TABLE temp_LOB_BATC(cid ClassID, id ObjID)
GO
DECLARE @cid ClassID, @id ObjID, @phy_id ObjID 
DECLARE cc CURSOR FOR select dst_id from link where dst_cid = 'LOB' AND deleted = 0 order by dst_id 
OPEN cc
FETCH NEXT FROM cc INTO @id 
WHILE @@FETCH_STATUS <> -1
BEGIN
  SELECT @cid = 'LOB', @phy_id = 0 
  exec asisp_followphysicallink @id, @cid out, @phy_id out
  IF @cid = 'BTCY'
    INSERT temp_LOB_BTCY SELECT @cid, @phy_id
  ELSE IF @cid = 'BATC'
    IF NOT EXISTS (SELECT * FROM temp_LOB_BATC WHERE id = @phy_id)
      INSERT temp_LOB_BATC SELECT @cid, @phy_id
  FETCH NEXT FROM cc INTO @id 
END
DEALLOCATE cc
GO

CREATE TABLE temp_btcy_ids(id ObjID)
GO
DECLARE @cid ClassID, @id ObjID, @phy_id ObjID 
DECLARE cc CURSOR FOR SELECT l.dst_id FROM link AS l 
  JOIN LineOfBusiness_V AS v ON v.id = l.src_id 
  AND v.name = 'CA7 COMPLEXES'
  AND l.src_cid = 'LOB' 
  AND l.dst_cid = 'LOB'
  AND l.deleted = 0  
OPEN cc
FETCH NEXT FROM cc INTO @id 
WHILE @@FETCH_STATUS <> -1
BEGIN
  SELECT @cid = 'LOB', @phy_id = 0 
  exec asisp_followphysicallink @id, @cid out, @phy_id out
  IF @cid = 'BCYS'
  BEGIN
    INSERT temp_btcy_ids 
      SELECT dst_id 
      FROM link 
      WHERE src_cid = 'BCYS' 
      AND src_id = @phy_id 
      AND link_type = 'AGGC' 
      AND deleted = 0
  END
  FETCH NEXT FROM cc INTO @id 
END
DEALLOCATE cc
GO

-- delete jobs which do not have LOB created
UPDATE BATCH_V SET deleted = 1 
  WHERE _ParentCID = 'BTCY' AND _ParentID IN (SELECT id FROM temp_btcy_ids)
  AND id NOT IN (SELECT id FROM temp_LOB_BATC)
  AND deleted = 0 

--insert should keep schedules
INSERT temp_LOB_BTCY SELECT DISTINCT 'BTCY', _ParentID 
  FROM BATCH_V 
  WHERE _ParentCID = 'BTCY' 
  AND _ParentID IN (SELECT id FROM temp_btcy_ids)
  AND deleted = 0 
GO
-- delete schedules which are not parents of batch jobs having LOB created
UPDATE link SET deleted = 1 
  WHERE src_cid = 'BTCY' 
  AND deleted = 0 
  AND src_id NOT IN (SELECT id FROM temp_LOB_BTCY)
  AND src_id IN (SELECT id FROM temp_btcy_ids)  
UPDATE link SET deleted = 1 
  WHERE dst_cid = 'BTCY' 
  AND deleted = 0 
  AND dst_id NOT IN (SELECT id FROM temp_LOB_BTCY)
  AND dst_id IN (SELECT id FROM temp_btcy_ids)  
UPDATE containment SET deleted = 1 
  WHERE src_cid = 'BTCY' 
  AND deleted = 0 
  AND src_id NOT IN (SELECT id FROM temp_LOB_BTCY)
  AND src_id IN (SELECT id FROM temp_btcy_ids)  
UPDATE containment SET deleted = 1 
  WHERE dst_cid = 'BTCY' 
  AND deleted = 0 
  AND dst_id NOT IN (SELECT id FROM temp_LOB_BTCY)
  AND dst_id IN (SELECT id FROM temp_btcy_ids)  
UPDATE BatchCycle_V SET deleted = 1 
  WHERE deleted = 0 
  AND id NOT IN (SELECT id FROM temp_LOB_BTCY)
  AND id IN (SELECT id FROM temp_btcy_ids)  
UPDATE BCYS_BTCY_AGGC SET deleted = 1 
  WHERE deleted = 0 
  AND dst_id NOT IN (SELECT id FROM temp_LOB_BTCY) 
  AND dst_id IN (SELECT id FROM temp_btcy_ids)  
GO

DROP TABLE temp_LOB_BTCY
GO
DROP TABLE temp_LOB_BATC
GO
DROP TABLE temp_btcy_ids
