-- archive/db/sql/ow51367.sql
-- SID: 1.1
-- Date Modified: 01/09/24 17:23:36
--
-- Module Description
--   Resolves defect OW51367: INVALID RECORD FROM CICS EXIT STOP S.E.L.
-- 
--   This changes the SJMessageMap table entry for transaction message
--   DFHAC2236 so that the transaction name, abend code, program name,
--   and termination code can all contain embedded spaces.

USE Object
GO

DECLARE @SearchExpression VARCHAR(255)
SET @SearchExpression = 'TRANSACTION [ ]*\([^ ].*\)[ ]* ABEND [ ]*\([^ ].*\)[ ]* IN PROGRAM [ ]*\([^ ].*\)[ ]* TERM \([^ ].*\)[ ]*'
UPDATE SJMessageMap SET 
  SearchExpression = @SearchExpression
WHERE
  MsgID = 'DFHAC2236'
  AND SearchExpression <> @SearchExpression
GO
