-- define the dump device for the OPCLoad database if it doesn't already exist

USE master
IF EXISTS (SELECT * FROM master..sysdatabases WHERE name = 'OPCLoad') AND
   NOT EXISTS (SELECT * FROM master..sysdevices WHERE name = 'OPCLoad') BEGIN
  DECLARE @path NVARCHAR(260)
  SELECT @path = REPLACE(filename,".MDF",".BAK") 
    FROM master..sysdatabases WHERE name = 'OPCLoad'
  SET @path = REPLACE(@path,".Mdf",".BAK")
  SET @path = REPLACE(@path,".mdf",".BAK")
  SET @path = REPLACE(@path,"\DATA\","\Backup\")
  SET @path = REPLACE(@path,"\Data\","\Backup\")
  SET @path = REPLACE(@path,"\data\","\Backup\")
  PRINT 'Adding dump device ' + @path + ' for OPCLoad database'
  EXEC sp_addumpdevice 'disk', 'OPCLoad', @path
END
