-- archive/db/sql/restoreeventhistory.sql
-- SID: 1.1
-- Date Modified: 01/09/28 15:18:42
--
-- restoreeventhistory.sql
--
-- Module Description
--   Restore the EventHistory database, if it exists and there's a dump device.

USE master
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'restoreEventHistory' AND type = 'P')
  DROP PROCEDURE restoreEventHistory
PRINT 'Creating restoreEventHistory'
GO

CREATE PROCEDURE restoreEventHistory
AS

SET NOCOUNT ON

IF EXISTS (SELECT * FROM master..sysdatabases WHERE name = 'EventHistory') AND
   EXISTS (SELECT * FROM master..sysdevices WHERE name = 'EventHistory') BEGIN

  SELECT 'message'='Restoring ' + db.filename + ' from ' + dev.phyname
    FROM master..sysdatabases db
    JOIN master..sysdevices dev ON dev.name = db.name
    WHERE db.name = 'EventHistory'

  RESTORE DATABASE EventHistory FROM EventHistory WITH FILE=1, STATS, REPLACE
END

GO
