-- $Header
--  This is part of History Server Set up using BCP Approach
--
--This file will create three scheduled tasks
--1. "Copy Backups to Hist Server" cp latest version of Object and Meta database backups 
--   to hist server with backup device name;
--2. "Move events to History Database" Move the entries in event table every 5 min.
--3. "Delete old entries in event table" Delete old entries in event table every day.
--
-- REPLACE "XXXX" with live server name such as "dell5"; 
-- REPLACE "HHHH" with hist server name such as "dell4"; 
-- REPLACE "YYYY" with live server backup path such as "e$/mssql7"
-- REPLACE "FFFF" with live server backup path such as "e$\mssql7"
-- REPLACE "ZZZZ" with hist server backup path such as "d$/mssql7"
-- REPLACE "IIII" with live server TBSM bin path such as "c$/TivoliManager/bin" 

exec msdb..sp_addtask 'Copy Backups to Hist Server', 
	@subsystem = 'CmdExec', 
	@server = null, 
	@username = null, 
	@databasename = null, 
	@enabled = 1, 
	@freqtype = 4, 
	@freqinterval = 1, 
	@freqsubtype = 1, 
	@freqsubinterval = 0, 
	@freqrelativeinterval = 1, 
	@freqrecurrencefactor = 1, 
	@activestartdate = 20000410, 
	@activeenddate = 99991231, 
	@activestarttimeofday = 4000, 
	@activeendtimeofday = 235959, 
	@runpriority = 0, 
	@emailoperatorname = null, 
	@retryattempts = 0, 
	@retrydelay = 0, 
	@loghistcompletionlevel = 2, 
	@emailcompletionlevel = 0, 
	@command = 'sh -c "//XXXX/IIII/CopyLiveBackupsToHist.ksh //XXXX/YYYY/backup //HHHH/ZZZZ/backup"', 
	@tagadditionalinfo = null, 
	@description = null, 
	@tagobjectid = 0, 
	@tagobjecttype = 0, 
	@cmdexecsuccesscode = 0
go
exec msdb..sp_addtask 'Move events to History Database', 
	@subsystem = 'TSQL', 
	@server = null, 
	@username = null, 
	@databasename = 'Object', 
	@enabled = 1, 
	@freqtype = 4, 
	@freqinterval = 1, 
	@freqsubtype = 4, 
	@freqsubinterval = 5, 
	@freqrelativeinterval = 1, 
	@freqrecurrencefactor = 1, 
	@activestartdate = 20000410, 
	@activeenddate = 99991231, 
	@activestarttimeofday = 20000, 
	@activeendtimeofday = 235959, 
	@runpriority = 0, 
	@emailoperatorname = null, 
	@retryattempts = 0, 
	@retrydelay = 0, 
	@loghistcompletionlevel = 2, 
	@emailcompletionlevel = 0, 
	@command = 'asisp_moveevent ''HHHH'', ''\\XXXX\FFFF\backup'', ''History'', ''eventhist''', 
	@tagadditionalinfo = null, 
	@description = null, 
	@tagobjectid = 0, 
	@tagobjecttype = 0, 
	@cmdexecsuccesscode = 0
go
exec msdb..sp_addtask 'Delete old entries in event table', 
	@subsystem = 'TSQL', 
	@server = null, 
	@username = null, 
	@databasename = 'Object', 
	@enabled = 1, 
	@freqtype = 4, 
	@freqinterval = 1, 
	@freqsubtype = 1, 
	@freqsubinterval = 0, 
	@freqrelativeinterval = 1, 
	@freqrecurrencefactor = 1, 
	@activestartdate = 20000410, 
	@activeenddate = 99991231, 
	@activestarttimeofday = 10000, 
	@activeendtimeofday = 235959, 
	@runpriority = 0, 
	@emailoperatorname = null, 
	@retryattempts = 0, 
	@retrydelay = 0, 
	@loghistcompletionlevel = 2, 
	@emailcompletionlevel = 0, 
	@command = 'asisp_deleteoldevent', 
	@tagadditionalinfo = null, 
	@description = null, 
	@tagobjectid = 0, 
	@tagobjecttype = 0, 
	@cmdexecsuccesscode = 0
go
