-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/tI_ExceptionHistory_A_BATC.sqv   1.0   Aug 14 2001 15:22:06   BRENT  $
--
-- tI_ExceptionHistory_A_BATC.sql
--
-- Module Description
--   Defines the tI_ExceptionHistory_A_BATC trigger


USE Object
GO


---------------------------------------------------------------------------------------------------
-- tI_ExceptionHistory_A_BATC
PRINT 'Creating trigger tI_ExceptionHistory_A_BATC'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type='TR' AND name='tI_ExceptionHistory_A_BATC')
  DROP TRIGGER tI_ExceptionHistory_A_BATC
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/tI_ExceptionHistory_A_BATC.sqv  $
-- $Revision:   1.0  $
-- $Date:   Aug 14 2001 15:22:06  $
-- $Author:   BRENT  $
-- Insert trigger on ExceptionHistory_A that inserts records into BatchCycleJobHist for
-- messages on batch jobs
CREATE TRIGGER tI_ExceptionHistory_A_BATC ON ExceptionHistory_A FOR INSERT WITH APPEND
AS
  INSERT INTO BatchCycleJobHist
  (
    agent_cid,
    agent_id,
    agent_ctime,
    agent_seqno,
    obj_cid,
    obj_id,
    eventcid,
    eventid,
    name,
    ctime,
    detail,
    alertstate,
    priority,
    currentstate,
    desiredstate
  )
  SELECT
    e._ParentCID,
    e._ParentID,
    i._TIME,
    i._SEQ_NO,
    e._ParentCID,
    e._ParentID,
    'EXCH',
    i.id,
    e._EXCP_NAME,
    CURRENT_TIMESTAMP,
    i._EXCP_CD,
    e._AlertState,
    e._Priority,
    0,
    b._DesiredStateID
  FROM
    inserted AS i
      JOIN Exception_A AS e ON e.id = i._ParentID
      JOIN BATCH_V AS b ON b.id = e._ParentID
  WHERE
    e._ParentCID = 'BATC'
GO
