-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/tI_Message_A_BATC.sqv   1.0   Aug 14 2001 15:22:06   BRENT  $
--
-- tI_Message_A_BATC.sql
--
-- Module Description
--   Defines the tI_Message_A_BATC trigger


USE Object
GO


---------------------------------------------------------------------------------------------------
-- tI_Message_A_BATC
PRINT 'Creating trigger tI_Message_A_BATC'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type='TR' AND name='tI_Message_A_BATC')
  DROP TRIGGER tI_Message_A_BATC
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/tI_Message_A_BATC.sqv  $
-- $Revision:   1.0  $
-- $Date:   Aug 14 2001 15:22:06  $
-- $Author:   BRENT  $
-- Insert trigger on Message_A that inserts records into BatchCycleJobHist for
-- messages on batch jobs
CREATE TRIGGER tI_Message_A_BATC ON Message_A FOR INSERT WITH APPEND
AS
  INSERT INTO BatchCycleJobHist
  (
    agent_cid,
    agent_id,
    agent_ctime,
    agent_seqno,
    obj_cid,
    obj_id,
    eventcid,
    eventid,
    name,
    ctime,
    detail,
    alertstate,
    priority,
    currentstate,
    desiredstate
  )
  SELECT
    i._ParentCID,
    i._ParentID,
    i._TIME,
    i._SEQ_NO,
    i._ParentCID,
    i._ParentID,
    'MESG',
    i.id,
    i._MESSAGE,
    CURRENT_TIMESTAMP,
    i._REASON_CD,
    i._AlertState,
    i._Priority,
    i._StateID,
    b._DesiredStateID
  FROM
    inserted AS i
      JOIN BATCH_V AS b ON b.id = i._ParentID
  WHERE
    i._ParentCID = 'BATC'
GO
